#include<stdio.h>
#include<string.h>
#include<malloc.h>
#include<map>
#include<vector>
#include<stack>

#define FILENAME_STATUS	"status.txt"
#define FILENAME_TABLE	"table.txt"


#define uint unsigned int

#define FLAG_R		128	//  
#define FLAG_ACC	127	//  


//#define GR_COUNT 3
//char *gr[]={"SCC","CaC","Cb"};

//#define GR_COUNT 5
//char *gr[]={"EE+T","ET","TT*F","TF","Fi"};

#define GR_COUNT 6
char *gr[]={"EE+T","ET","TT*F","TF","F(E)","Fi"};
char test_line[]="i+i*i";

//#define GR_COUNT 5
//char *gr[]={"SL=R","SR","L*R","Li","RL"};

//#define GR_COUNT 6
//char *gr[]={"SaAd","SbBd","SaBe","SbAe","Ac","Bc"};

//#define GR_COUNT 4
//char *gr[]={"EE+E","EE*E","E(E)","Ei"};

//#define GR_COUNT 3
//char *gr[]={"SiSeS","SiS","Sa"};

//#define GR_COUNT 4
//char *gr[]={"EEsEsE","EEsE","E(E)","c"};

//    ( )

class CharSet {
	char *set; 
public:
	CharSet();
	~CharSet();
	void Copy(CharSet*);	//    
	bool Intersect(char*); 	//   
	bool Add(char);		//  
	bool isIn(char);	//    
	char *Get();		//   
	char Get(uint);		//    
	uint GetSize();		//   
	uint GetHash();		//   
};

CharSet::CharSet()
{
	set=(char*)malloc(1); set[0]=0;
}

CharSet::~CharSet()
{
	free(set);
}


void CharSet::Copy(CharSet *obj)
{
	free(set); set=strdup(obj->set);
}

bool CharSet::Intersect(char *add)
{
	int n,m; char sym;
	char *buff=(char*)alloca(strlen(set)+1);
	for(n=m=0; add[n]; n++) if(!strchr(set,add[n])) buff[m++]=add[n];
	if(!m) return false; buff[m++]=0;
	set=(char*)realloc(set,m+strlen(set));
	strcat(set,buff);
	for(n=0; set[n]; n++) for(m=n+1; set[m]; m++) if(set[n]>set[m]) sym=set[n],set[n]=set[m],set[m]=sym;
	return true;
}

bool CharSet::Add(char sym)
{
	char buff[2]; buff[0]=sym; buff[1]=0;
	return Intersect(buff);
}

bool CharSet::isIn(char sym)
{
	return strchr(set,sym)!=0;
}


char CharSet::Get(uint index)
{
	if(index>=strlen(set)) return 0;
	return set[index];
}

char *CharSet::Get()
{
	return set;
}


uint CharSet::GetSize()
{
	return strlen(set);
}

uint CharSet::GetHash()
{
	uint hash=strlen(set); uint n;
	for(n=0; n<(int)strlen(set); n++) hash+=set[n];
	return hash;
}


//  

CharSet charset,t_charset;	//   ,   
CharSet *first_set; // first 

//  first   
char *GetSet(char sym)
{
	for(uint n=0; n<charset.GetSize(); n++) if(charset.Get()[n]==sym) return first_set[n].Get();
	return "?";
}

//    frist   
bool AddSet(char sym,char *set)
{
	for(uint n=0; n<charset.GetSize(); n++) if(charset.Get(n)==sym) return first_set[n].Intersect(set);
	return false;
}

//    frist   
bool AddSet(char sym,char add)
{
	char buff[2]; buff[0]=add; buff[1]=0;
	return AddSet(sym,buff);
}

//   
void InstallSets()
{
//  
	uint line,pos,n; bool next;
	for(line=0; line<GR_COUNT; line++) charset.Add(gr[line][0]);
	for(line=0; line<GR_COUNT; line++) for(pos=1; pos<strlen(gr[line]); pos++) if(!charset.isIn(gr[line][pos])) t_charset.Add(gr[line][pos]);
	t_charset.Add('$'); charset.Intersect(t_charset.Get());
	printf("charset: [%s]\n",charset.Get());
	printf("t_charset: [%s]\n",t_charset.Get());
//  frist 
	first_set=new CharSet[charset.GetSize()];
	for(n=0; n<charset.GetSize(); n++) AddSet(t_charset.Get()[n],t_charset.Get(n));
	do { next=false;
		for(line=0; line<GR_COUNT; line++) next=AddSet(gr[line][0],GetSet(gr[line][1]))||next;
	} while(next);
	printf("[first chars]\n");
	for(n=0; n<charset.GetSize(); n++) printf("%c: %s\n",charset.Get()[n],first_set[n].Get());
	printf("\n");
}

//     

class Item{
public:
	int line; int pos; CharSet set;
	Item();
	Item(const Item&);
	Item(int,int,char*);
	bool Compare(Item*); //  
};

Item::Item()
{}

Item::Item(const Item&obj)
{
	line=obj.line; pos=obj.pos; set.Copy((CharSet*)&obj.set);
}

Item::Item(int line_,int pos_,char* set_)
{
	line=line_; pos=pos_; set.Intersect(set_);
}

bool Item::Compare(Item *obj)
{
	return line==obj->line && pos==obj->pos && !strcmp(set.Get(),obj->set.Get());
}


//   	
class Status{
	int hash;
	std::vector<Item>array;
	bool Add(int,int,char*); //  
	void Complement();	 //   (  + )
public:
	Status();
	Status(const Status&);	
	~Status();
	void Start();		//   
	void Dump(FILE*);	// 
	void Copy(Status*);	//  
	bool Compare(Status*);	// 
	bool Step(char sym);	//    
	int GetSize();		//     
	Item *GetItem(int);	//   
};

Status::Status()
{}

Status::Status(const Status& obj)
{
	Copy((Status*)&obj);
}

Status::~Status()
{}

void Status::Start()
{
	for(int line=0; line<GR_COUNT; line++) if(gr[0][0]==gr[line][0]) Add(line,0,"$");
	Complement();
}

void Status::Copy(Status*obj)
{
	hash=obj->hash; uint n;
	array.clear();
	array.reserve(obj->GetSize());
	for(n=0; n<obj->GetSize(); n++) array.push_back(obj->array[n]);
}

void Status::Dump(FILE *file)
{
	uint line,pos,n,m; char *set;
	for(n=0; n<GetSize(); n++) {
		line=array[n].line; pos=array[n].pos; set=array[n].set.Get();
		fprintf(file,"%c: ",gr[line][0]); if(!pos) fputc('.',file);
		for(m=1; m<strlen(gr[line]); m++) {fputc(gr[line][m],file); if(pos==m) fputc('.',file);}
		fprintf(file,"\t[%s]\n",set);
	}
}

bool Status::Step(char sym)
{
	uint line,pos,n; Status obj;
	for(n=0; n<GetSize(); n++) {
		line=array[n].line; pos=array[n].pos;
		if(gr[line][pos+1]==sym) obj.Add(line,pos+1,array[n].set.Get());
	}
	Copy(&obj);
	Complement();
	return !array.empty();
}

bool Status::Compare(Status *obj)
{
	if(hash!=obj->hash || GetSize()!=obj->GetSize()) return false;
	for(uint n=0; n<GetSize(); n++) if(!array[n].Compare(&obj->array[n])) return false;
	return true;
}

bool Status::Add(int line,int pos,char *set)
{
	for(uint n=0; n<GetSize(); n++) if(array[n].line==line && array[n].pos==pos) return false;
	Item item(line,pos,set);
	array.push_back(item);
	return true;
}

int Status::GetSize()
{
	return array.size();
}

Item *Status::GetItem(int index)
{
	return &array[index];
}


void Status::Complement()
{
	uint n,m,line,pos; char sym1,sym2; char *set;
//  
	for(n=0; n<GetSize(); n++) {
		line=array[n].line; pos=array[n].pos;
		for(m=0; m<GR_COUNT; m++) if(gr[m][0]==gr[line][pos+1]) Add(m,0,"");
	}
//  
	for(n=0; n<GetSize(); n++) {
		line=array[n].line; pos=array[n].pos;
		sym1=gr[line][pos+1]; sym2=gr[line][pos+2]; if(!sym1) continue;
		if(sym2) set=GetSet(sym2); else set=array[n].set.Get();
		for(m=0; m<GetSize(); m++) {
			if(gr[array[m].line][0]==sym1) array[m].set.Intersect(set);
		}
	}
//   
	hash=GetSize();
	for(n=0; n<GetSize(); n++) hash+=array[n].line+array[n].pos+array[n].set.GetHash();
}



//   
std::vector<Status>status_array;

//         
int AddStatus(Status* obj)
{
	uint n;
	for(n=0; n<status_array.size(); n++) if(status_array[n].Compare(obj)) return n;
	status_array.push_back(*obj);
	return n;
}

//   
void DumpStatusList()
{
	FILE *file=fopen(FILENAME_STATUS,"wt");
//	fprintf(file,"[status list]\n");
	for(uint n=0; n<status_array.size(); n++) {
		fprintf(file,"\n[status %d]\n",n);
		status_array[n].Dump(file);
	}
	fclose(file);
}


//    

class TableItem{
public:
	int status; char sym;
	TableItem();
	TableItem(const TableItem&);
};

TableItem::TableItem()
{}

TableItem::TableItem(const TableItem& item)
{
	status=item.status; sym=item.sym;
}

operator <(const TableItem& item1,const TableItem& item2)
{
	return item1.status==item2.status && item1.sym<item2.sym || item1.status<item2.status;
}

operator ==(const TableItem& item1,const TableItem& item2)
{
	return item1.status==item2.status && item1.sym==item2.sym;
}

std::map<TableItem,int>table; //    

void AddTable(TableItem *item,int to)
{
	std::map<TableItem,int>::iterator it=table.find(*item);
	if(it!=table.end()) { printf("collision\n\a"); return;}
	table.insert(std::make_pair<TableItem,int>(*item,to));
}


//   
void Work()
{
	Status obj; uint n,m,i,to; TableItem tab_item; Item *item;
	obj.Start();
	AddStatus(&obj);
//  
	for(n=0; n<status_array.size(); n++) {
		for(m=0; m<charset.GetSize(); m++) {
			obj.Copy(&status_array[n]);
			if(obj.Step(charset.Get(m))) {
				tab_item.status=n; tab_item.sym=charset.Get(m);
				to=AddStatus(&obj); AddTable(&tab_item,to);
			}
		}
	}
//  
	for(n=0; n<status_array.size(); n++) {
		tab_item.status=n;
		for(m=0; m<charset.GetSize(); m++) {
			obj.Copy(&status_array[n]); tab_item.sym=charset.Get(m);
			for(i=0; i<obj.GetSize(); i++) {
				item=obj.GetItem(i); 
				if(gr[item->line][item->pos+1]) continue;
				if(!item->set.isIn(tab_item.sym)) continue;
				to=FLAG_R|item->line; 
				if(gr[item->line][0]==gr[0][0] && tab_item.sym=='$') to=FLAG_ACC;
				AddTable(&tab_item,to);
				break;
			}
		}
	}
}

//   
void DumpTable()
{
	uint n,m; int r; TableItem item;
	FILE *file=fopen(FILENAME_TABLE,"wt");
//	fprintf(file,"\n[table]\n");
	fputc(' ',file); 
	for(m=0; m<charset.GetSize(); m++) fprintf(file,"|%c",charset.Get(m)); fputc('\n',file);
	for(n=0; n<status_array.size(); n++) {
		fprintf(file,"%d ",n);
		for(m=0; m<charset.GetSize(); m++) {
			item.status=n; item.sym=charset.Get(m);
			std::map<TableItem,int>::iterator it=table.find(item);
			if(it==table.end()) r=-1; else r=(it)->second;
			if(r<0) fprintf(file,"|");
			else if(r==FLAG_ACC) fprintf(file,"|ACC");
			else if(r&FLAG_R) fprintf(file,"|R%d",r^FLAG_R);
			else fprintf(file,"|%d",r);
		}
		fputc('\n',file);
	}
	fclose(file);
}



//  
bool Parse() 
{
	printf("[Parser]\n");
	std::stack<TableItem>parse_stack; //  
	int read_index=0; char sym; int n,m;
	std::map<TableItem,int>::iterator it;
	TableItem sp; sp.status=0; sp.sym=gr[0][0];
	parse_stack.push(sp);
label1:
	sym=test_line[read_index++]; if(!sym) sym='$'; sp.sym=sym;
label2:
	printf("status:%d   sym:%c\n",sp.status,sp.sym);
	it=table.find(sp); if(it==table.end()) return false;
	sp.status=(it)->second;
	if(sp.status==FLAG_ACC) { printf("accept\n"); return true;}
	if(!(sp.status&FLAG_R)) { parse_stack.push(sp); goto label1;}
	n=sp.status^FLAG_R;
	printf("scroll[%d]: %s\n",n,gr[n]);
	for(m=strlen(gr[n])-1; m; m--) {
		sp=parse_stack.top(); parse_stack.pop();
		if(gr[n][m]!=sp.sym) { printf("internal error.\n"); return false;}
	}
	read_index--;
	sp=parse_stack.top(); sp.sym=gr[n][0];
	goto label2;
}



void main()
{
	InstallSets();
	Work();
	DumpStatusList();
	DumpTable();
	printf("parse %s..\n",Parse()?"Ok":"error");
	printf("press enter\n");getchar();

}




